%define soversion 0
%define thread_test_threads %{?threads:%{threads}}%{!?threads:100}

Summary: The OpenSSL toolkit.
Name: openssl095a
Version: 0.9.5a
Release: 24.8.legacy
Source: openssl-%{version}-usa.tar.bz2
Source1: hobble-openssl
Source2: Makefile.certificate
Source8: openssl-thread-test.c
Patch0: openssl-0.9.5a-redhat.patch
Patch1: openssl-0.9.5-rsanull.patch
Patch2: openssl-0.9.5a-64.patch
Patch3: openssl-0.9.5a-defaults.patch
Patch4: openssl-0.9.5a-ia64.patch
Patch5: openssl-0.9.5a-glibc.patch
Patch6: openssl-0.9.5a-ev5.patch
Patch8: openssl-0.9.5a-bleichenbacher.patch
Patch9: openssl-crt.patch
Patch10: openssl-setugid.patch
Patch11: openssl-zero-premaster.patch
Patch12: openssl-0.9.6-memmove.patch
Patch13: openssl096a-prng.patch
Patch14: openssl096a-prng-2.patch
Patch15: openssl-0.9.5a-sec.patch
Patch16: openssl-0.9.6c-asn.patch.3
Patch20: openssl-0.9.5a-linux-s390.patch
Patch21: openssl-0.9.6-malloc-negative.patch
Patch22: openssl-0.9.6-vaudenay.patch
Patch23: openssl-sec3-blinding-0.9.6b.patch
Patch24: openssl-0.9.5a-klima-pokorny-rosa.patch
Patch25: openssl-0.9.5a-blinding-threads.patch
Patch26: openssl-0.9.5a-blinding-rng.patch
Patch27: niscc-095.txt
Patch28: openssl-0.9.6-nodie.patch
Patch29: openssl-0.9.6c-ccert.patch
Patch30: openssl-0.9.6b-recursion.patch
Patch31: openssl-0.9.6c-spinfix.patch
License: BSDish
Group: System Environment/Libraries
URL: http://www.openssl.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: bc, perl, python-devel, unzip
ExcludeArch: s390 s390x
Conflicts: openssl <= %{version}

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%prep
%setup -q -n openssl-%{version}
%{SOURCE1}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .rsanull
%ifarch alpha ia64
%patch2 -p1 -b .64
%endif
%patch3 -p1 -b .defaults
%patch4 -p1 -b .ia64
%patch5 -p1 -b .glibc
%patch6 -p1 -b .ev5

%ifarch s390
%patch20 -p1 -b .s390
%endif
%patch8 -p1 -b .bleichenbacher
%patch9 -p1 -b .crt
%patch10 -p1 -b .setugid
%patch11 -p1 -b .zero-premaster
%patch12 -p1 -b .memmove
pushd crypto/rand
%patch13 -p0 -b .prng
popd
pushd doc/crypto
%patch14 -p0 -b .prng-2
popd
%patch15 -p0 -b .sec
%patch16 -p1 -b .asn

%patch21 -p1 -b .malloc-negative
%patch22 -p1 -b .vaudenay
%patch23 -p0 -b .sec3-blinding
pushd ssl
%patch24 -p0 -b .klima-pokorny-rosa
popd
%patch25 -p1 -b .blinding-threads
%patch26 -p1 -b .blinding-rng
%patch27 -p1 -b .niscc
%patch28 -p1 -b .nodie
%patch29 -p1 -b .ccert
%patch30 -p1 -b .recursion
%patch31 -p1 -b .spinfix

chmod 644 FAQ LICENSE CHANGES NEWS INSTALL README
chmod 644 doc/README doc/c-indentation.el doc/openssl.txt
chmod 644 doc/openssl_button.html doc/openssl_button.gif
chmod 644 doc/ssleay.txt

# Link the configuration header to the one we're going to make.
ln -sf ../../crypto/opensslconf.h include/openssl/
# Link the ssl.h header to the one we're going to make.
ln -sf ../../ssl/ssl.h include/openssl/

%build 
PATH=${PATH}:${PWD}/bin
TOPDIR=${PWD}

# Figure out which flags we want to use.  Assembly is broken on some platforms,
# required on others.
perl util/perlpath.pl `dirname %{__perl}`
sslarch=%{_os}-%{_arch}
%ifarch %ix86
sslarch=linux-elf
sslflags=no-asm
%endif
%ifarch sparc
sslarch=linux-sparcv9
sslflags=no-asm
%endif
%ifarch ppc
sslarch=linux-ppc
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -O1"
%endif
%ifarch ppc64
sslarch=linux-ppc
sslflags=no-asm
%endif
%ifarch ia64
sslarch=linux-ia64
sslflags=no-asm
%endif
%ifarch alpha
sslarch=linux-alpha-gcc
sslflags=no-asm
%endif
%ifarch s390
sslarch=linux-s390
%endif
%ifarch s390x
sslarch=linux-s390x
%endif
%ifarch x86_64
sslarch=linux-x86_64
%endif
# Configure the build tree.  Override OpenSSL defaults with known-good defaults
# usable on all platforms.
RPM_OPT_FLAGS="-fPIC $RPM_OPT_FLAGS"
./Configure --prefix=%{_prefix} --openssldir=%{_datadir}/ssl ${sslflags} no-idea no-mdc2 no-rc5 no-md2 ${sslarch}
make all

# Build the Perl bindings.
#pushd perl
#perl Makefile.PL
#make
#popd

# Verify that what was compiled actually works.
LD_LIBRARY_PATH=`pwd`${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
export LD_LIBRARY_PATH
make -C test apps tests
%{__cc} -o openssl-thread-test \
	-I./include \
	$RPM_SOURCE_DIR/openssl-thread-test.c \
	libssl.a libcrypto.a \
	-lpthread -lz -ldl
./openssl-thread-test --threads %{thread_test_threads}

# Build shared libraries.
for shlib in crypto ssl ; do
	pushd $shlib
		objs=`ar t ../lib${shlib}.a | xargs -n 1 find . -name`
		%{__cc} -shared -o ../lib${shlib}.so.%{version} \
			-Wl,-soname=lib${shlib}.so.%{soversion} $objs && \
		ln -sf lib${shlib}.so.%{version} ../lib${shlib}.so.%{soversion}
		ln -sf lib${shlib}.so.%{version} ../lib${shlib}.so
	popd
done

# Relink the main binary to get it dynamically linked.
rm apps/openssl
make all

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
# Install just the shared libraries.
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir},%{_mandir}}
install -m 755 *.so.%{version} $RPM_BUILD_ROOT%{_libdir}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%doc FAQ LICENSE CHANGES NEWS INSTALL README
%doc doc/README doc/c-indentation.el doc/openssl.txt
%doc doc/openssl_button.html doc/openssl_button.gif
%doc doc/ssleay.txt
%attr(0755,root,root) %{_libdir}/*.so.*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog
* Thu Mar 18 2004 Jesse Keating <jkeating@j2solutions.net>
- 0.9.5a-24.8.legacy
- add security fixes for CAN-2004-0081 and CAN-2003-0851

* Wed Sep 24 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-23.8
- rebuild

* Wed Sep 24 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-23.7.3
- rebuild

* Wed Sep 24 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-23.7.1
- backported backport from Joe Orton for changes in OpenSSL 0.9.6e and later,
  removing die-on-error code and replacing with error reporting
- only parse a client cert if one was requested

* Tue Sep 23 2003 Nalin Dahyabhai <nalin@redhat.com>
- add security fixes for protocol parsing bugs (CAN-2003-0543, CAN-2003-0544)
- ease back on the number of threads used in the threading test

* Wed Jul 14 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-22.7.1
- rebuild

* Mon Jul 14 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-22.8
- rebuild

* Mon Jul 14 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-22.7
- rebuild with updated thread test

* Fri Jun 13 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-21.8
- rebuild

* Wed Jun 11 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-21.7
- thread-safety fix for RSA blinding
- backport fix for prng not being seeded causing problems from 0.9.7b
- add a check at build-time to ensure that RSA is thread-safe

* Wed Mar 19 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-20.7
- rebuild for previous release

* Wed Mar 19 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-21
- add backported patch to harden against Klima-Pokorny-Rosa extension
  of Bleichenbacher's attack (CAN-2003-0131)

* Mon Mar 17 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-20
- add patch to enable RSA blinding by default, closing a timing attack
  (CAN-2003-0147)

* Wed Feb 19 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-19
- add fix to guard against attempts to allocate negative amounts of memory
- add patch for CAN-2003-0078, fixing a timing attack

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Nov 19 2002 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-17
- install just the shared libraries

* Wed Jul 31 2002 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-16
- rebuild

* Mon Jul 29 2002 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-15
- add patch to fix ASN.1 vulnerabilities

* Thu Jul 25 2002 Nalin Dahyabhai <nalin@redhat.com> 0.9.5a-14
- add backport of Ben Laurie's patches for OpenSSL 0.9.6d

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Aug  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- conflict with openssl <= %{version} (#49382)

* Tue Jul 24 2001 Nalin Dahyabhai <nalin@redhat.com>
- bump release number and rebuild

* Thu Jul 12 2001 Nalin Dahyabhai <nalin@redhat.com>
- stop building the python extensions
- add bc as a build prereq, for the test suites

* Wed Jul 11 2001 Nalin Dahyabhai <nalin@redhat.com>
- add patches to fix PRNG flaws, supplied by Bodo Moeller and the OpenSSL Group

* Tue Jun 19 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add ExcludeArch: s390 s390x

* Fri Jun  1 2001 Nalin Dahyabhai <nalin@redhat.com>
- change two memcpy() calls to memmove()

* Sun May 27 2001 Philip Copeland <copeland@redhat.com>
- removed -DL_ENDIAN for the alpha builds as unsigned long=8 not 4
  which both L_ENDIAN / B_ENDIAN require to work correctly

* Thu May 17 2001 Nalin Dahyabhai <nalin@redhat.com>
- remove bogus provides

* Thu Apr 27 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild

* Fri Apr 20 2001 Nalin Dahyabhai <nalin@redhat.com>
- use __libc_enable_secure in OPENSSL_setugid (suggested by solar@openwall.com)
- make backported OPENSSL_setugid, BN_bntest_rand, and BN_rand_range static
  functions, which keeps them away from client applications more cleanly

* Tue Apr 17 2001 Nalin Dahyabhai <nalin@redhat.com>
- backport security fixes from 0.9.6a

* Fri Mar  2 2001 Nalin Dahyabhai <nalin@redhat.com>
- rename to openssl095a

* Wed Feb 28 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- change hopple-openssl for disabling MD2 again

* Tue Feb 27 2001 Nalin Dahyabhai <nalin@redhat.com>
- re-disable MD2 -- the EVP_MD_CTX structure would grow from 100 to 152
  bytes or so, causing EVP_DigestInit() to zero out stack variables in
  apps built against a version of the library without it

* Mon Feb 26 2001 Nalin Dahyabhai <nalin@redhat.com>
- disable some inline assembly, which on x86 is Pentium-specific
- re-enable MD2 (see http://www.ietf.org/ietf/IPR/RSA-MD-all)

* Thu Feb 08 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- fix s390 patch

* Fri Dec 8 2000 Than Ngo <than@redhat.com>
- added support s390

* Mon Nov 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove -Wa,* and -m* compiler flags from the default Configure file (#20656)
- add the CA.pl man page to the perl subpackage

* Thu Nov  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- always build with -mcpu=ev5 on alpha

* Tue Oct 31 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a symlink from cert.pem to ca-bundle.crt

* Wed Oct 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a ca-bundle file for packages like Samba to reference for CA certificates

* Tue Oct 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove libcrypto's crypt(), which doesn't handle md5crypt (#19295)

* Mon Oct  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- add unzip as a buildprereq (#17662)
- update m2crypto to 0.05-snap4

* Tue Sep 26 2000 Bill Nottingham <notting@redhat.com>
- fix some issues in building when it's not installed

* Wed Sep  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- make sure the headers we include are the ones we built with (aaaaarrgh!)

* Fri Sep  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- add Richard Henderson's patch for BN on ia64
- clean up the changelog

* Tue Aug 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix the building of python modules without openssl-devel already installed

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- byte-compile python extensions without the build-root
- adjust the makefile to not remove temporary files (like .key files when
  building .csr files) by marking them as .PRECIOUS

* Sat Aug 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- break out python extensions into a subpackage

* Mon Jul 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- tweak the makefile some more

* Tue Jul 11 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable MD2 support

* Thu Jul  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable MDC2 support

* Sun Jul  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- tweak the disabling of RC5, IDEA support
- tweak the makefile

* Thu Jun 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- strip binaries and libraries
- rework certificate makefile to have the right parts for Apache

* Wed Jun 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- use %%{_perl} instead of /usr/bin/perl
- disable alpha until it passes its own test suite

* Fri Jun  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- move the passwd.1 man page out of the passwd package's way

* Fri Jun  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 0.9.5a, modified for U.S.
- add perl as a build-time requirement
- move certificate makefile to another package
- disable RC5, IDEA, RSA support
- remove optimizations for now

* Wed Mar  1 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- Bero told me to move the Makefile into this package

* Wed Mar  1 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- add lib*.so symlinks to link dynamically against shared libs

* Tue Feb 29 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- update to 0.9.5
- run ldconfig directly in post/postun
- add FAQ

* Sat Dec 18 1999 Bernhard Rosenkr)Bnzer <bero@redhat.de>
- Fix build on non-x86 platforms

* Fri Nov 12 1999 Bernhard Rosenkr)Bnzer <bero@redhat.de>
- move /usr/share/ssl/* from -devel to main package

* Tue Oct 26 1999 Bernhard Rosenkr)Bnzer <bero@redhat.de>
- inital packaging
- changes from base:
  - Move /usr/local/ssl to /usr/share/ssl for FHS compliance
  - handle RPM_OPT_FLAGS
